.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 100000

ShowCpu	PROTO:DWORD

csize macro algo, txt		;; code size macro, requires label MyProc_END:
LOCAL  tmp$
  tmp$ CATSTR <algo>, <            >	;; 12 blanks
  tmp$ SUBSTR tmp$, 1, 12
  tmp$ CATSTR <print ">, tmp$, < = ">
  tmp$
  mov eax, offset &algo&_END-&algo&
  ifb <txt>
	print str$(eax), 13, 10
  else
	print str$(eax)
	print <txt>, 13, 10
  endif
ENDM

.data
MyQword		dq	12345678901234567890

.data?
AscBuf	dd 10 dup(?)
AscBuf2	dd 10 dup(?)
ForLingo	dd ?, ?

.code
start:	invoke ShowCpu, 1
	mov eax, dword ptr MyQword[0]
	mov dword ptr ForLingo[4], eax
	mov eax, dword ptr MyQword[4]
	mov dword ptr ForLingo[0], eax
	print chr$(13, 10, "Qword to Ascii algos:", 13, 10)
	REPEAT 3
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov edx, dword ptr MyQword[4]
		mov eax, dword ptr MyQword[0]
		call Asc64
	counter_end
	print str$(eax), 9, "cycles for Asc64, result:  ", 9
	print offset AscBuf, 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset AscBuf2
		push dword ptr MyQword[4]
		push dword ptr MyQword[0]
		call U64ToStr
	counter_end
	print str$(eax), 9, "cycles for U64ToStr, result: ", 9
	print offset AscBuf, 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset ForLingo
		push offset AscBuf2
		call b2a3264
	counter_end
	print str$(eax), 9, "cycles for b2a3264, result: ", 9
	print offset AscBuf, 13, 10

	print chr$(10)
	ENDM
	print chr$(13, 10, "Code sizes: ", 13, 10)
	csize Asc64
	csize U64ToStr
	csize b2a3264, " + 200 for chartable"

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

Asc64 proc
;Convert 64-bit unsigned integer to ASCII decimal string
;Call With: EDX:EAX= QWORD value to display
;
; Returns: EDI= Offset into AscBuf of first numchar

	std
	mov edi,offset AscBuf+18
	mov ecx,edx
	xchg eax,esi
	mov ebx,100

Asc64a: xor edx,edx
	xchg eax,ecx
	div ebx
	xchg eax,ecx
	xchg eax,esi
	div ebx
	xchg eax,esi
	xchg eax,edx
	aam
	xchg al,ah
	or ax,3030h
	stosw
	mov eax,ecx
	or eax,esi
	jnz Asc64a

	inc edi
	inc edi
	cmp byte ptr [edi],30h		;leading 0 ?
	cld
	jz Asc64b		;yes - supress it

	ret		;no - done

Asc64b: inc edi
	ret

Asc64 endp
Asc64_END:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

U64ToStr proc QwVal:QWORD, pszString:DWORD
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
	push ebp
	push esi
	push edi
	push ebx
	mov esi,[esp+1*4][4*4]; a0
	mov edi,[esp+2*4][4*4]; a1
	mov ebp,[esp+3*4][4*4]; buffer pointer
	test edi,edi
	jz @F
	;; QWORD conversion loop
@@U64Cvt:
	mov eax,0CCCCCCCDh; = b0
	mul esi; get a0*b0 = d1:d0
	mov ecx,edx;d1
	mov eax,0CCCCCCCDh; = b0
	xor ebx,ebx
	mul edi; get a1*b0 = e1:e0
	add ecx,eax;e0
	adc ebx,edx;e1
	mov eax,0CCCCCCCCh; =b1
	mul esi; get a0*b1 = f1:f0
	add ecx,eax;f0
	adc ebx,edx;f1
	mov ecx,0
	mov eax,0CCCCCCCCh; =b1
	adc ecx,ecx
	mul edi; get a1*b1 = g1:g0
	add eax,ebx;g0
	adc edx,ecx;g1
	shrd eax,edx,3
	shr edx,3;;------ quotient in edx::eax
	; upper dwords will be the same after multiplication
	lea ecx,[eax*4+eax]
	mov ebx,esi
	lea ecx,[ecx+ecx-'0']
	sub ebx,ecx
	mov esi,eax
	mov [ebp],bl
	mov edi,edx
	add ebp,1
	test edi,edi
	jnz @@U64Cvt
@@:
	;; we are here if HI-DWORD is 0
	mov eax,esi
	mov ebx,esi
	mov edi,0CCCCCCCDh
	;; Lower Dword conversion loop 
@@U32Cvt:
	mul edi
	shr edx,3
	lea ecx,[edx*4+edx]
	lea ecx,[ecx+ecx-'0']
	sub ebx,ecx
	mov eax,edx
	mov [ebp],bl
	mov ebx,edx
	add ebp,1
	test eax,eax
	jnz @@U32Cvt
	;; Calculate output string length and reverse it
	mov edi,[esp+3*4][4*4]
	mov [ebp],al
	mov eax,ebp
	sub eax,edi
	;; reverse buffer digits
@@:	sub ebp,1
	mov bl,[edi]
	mov cl,[ebp]
	mov [ebp],bl
	mov [edi],cl
	add edi,1
	cmp edi,ebp
	jb @B
	;; string length in eax
	pop ebx
	pop edi
	pop esi
	pop ebp
	ret 3*4
U64ToStr endp
U64ToStr_END:

b2a3264 proc lpbuf:DWORD, lpNumber:DWORD	; unsigned QWORD or DWORD to ASCII	

.data
;The character look up table. Make sure it's aligned suitably
align 16
chartab	dw "00","10","20","30","40","50","60","70","80","90"
	dw "01","11","21","31","41","51","61","71","81","91"
	dw "02","12","22","32","42","52","62","72","82","92"
	dw "03","13","23","33","43","53","63","73","83","93"
	dw "04","14","24","34","44","54","64","74","84","94"
	dw "05","15","25","35","45","55","65","75","85","95"
	dw "06","16","26","36","46","56","66","76","86","96"
	dw "07","17","27","37","47","57","67","77","87","97"
	dw "08","18","28","38","48","58","68","78","88","98"
	dw "09","19","29","39","49","59","69","79","89","99"
.code
	mov edx, [esp+2*4]
	mov eax, 0D1B71759h
	mov [esp+2*4], edi
	cmp dword ptr [edx], 0
	jne Lb2a64

; 32 bit Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
	mov edi, [edx+4]
	sub esp, 3*4
	mov [esp+1*4], esi
	mul edi
	mov ecx, [esp+1*4+3*4]
	shr edx, 13
	mov eax, 68DB9h
	je LoNext3
	imul esi, edx, 10000
	sub edi, esi
	mul edx
	mov esi, 100
	jnc LoNext1
	cmp edx, 9
	jc Lo0
	mov edx, dword ptr chartab[edx+edx]
	add ecx, 8
	mov [ecx-8], edx
Lo1:
	mul esi
Lo1a:
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx-6], edx
Lo2:
	mul esi
Lo2a:
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx-4], edx
Lo3:
	mov eax, 28F5C29h
	mul edi
Lo3a:
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx-2], edx
Lo4:
	mul esi
Lo4a:
	mov esi, [esp+1*4]
	add esp, 3*4
	mov edi, [esp+2*4]
	movzx edx, word ptr chartab[edx+edx]
	lea eax, [ecx+2]
	mov [ecx], edx
	ret 2*4
align 16
Lo0:
	add edx, 30h
	mov [ecx], edx
	add ecx,7
	jne Lo1
align 16
LoNext1:
	mul esi
	jnc LoNext2
	cmp edx, 9
	lea ecx, [ecx+6]
	ja Lo1a
	add edx, 30h
	sub ecx, 1
	mov [ecx-5], edx
	jnz Lo2
align 16
LoNext2:
	mul esi
	jnc LoNext3
	cmp edx, 9
	lea ecx, [ecx+4]
	ja Lo2a
	add edx, 30h
	sub ecx, 1
	mov [ecx-3], edx
	jnz Lo3
align 16
LoNext3:
	mov eax, 28F5C29h
	mul edi
	mov esi, 100
	jnc LoNext4
	cmp edx, 9
	lea ecx, [ecx+2]
	ja Lo3a
	add edx, 30h
	sub ecx, 1
	mov [ecx-1], edx
	jnz Lo4
align 16
LoNext4:
	mul esi
	cmp edx, 9
	ja Lo4a
	mov esi, [esp+1*4]
	add edx, 30h
	mov edi, [esp+2*4+3*4]
	add esp, 3*4
	mov [ecx], edx
	lea eax, [ecx+1]
	ret 2*4

; 64 bit Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros
align 16
Lb2a64:
	mov edi, [edx+4]
	mov eax, 095CD810h
	mov esi, [edx]
	sub esp, 3*4
	mul edi
	mov [esp+2*4+3*4], ebp
	mov eax, 095CD810h
	mov ebp, edx
	mul esi
	mov [esp], ebx
	add ebp, eax
	mov eax, 0B424DC35h
	adc edx, 0
	mov ebx, edx
	mul edi
	add ebp, eax
	mov eax, 0B424DC35h
	adc ebx, edx
	mul esi
	add ebx, eax
	adc edx, 0
	add ebp, 16384
	adc ebx, 0
	adc edx, 0
	shrd ebp, ebx, 14
	mov eax, 1000000
	shrd ebx, edx, 14
	mov esi, edx
	mul ebp
	shr esi, 14
	mov eax, 1000000
	mov ecx, edx
	mul ebx
	add ecx, eax
	adc edx, 0
	imul ecx, esi, 1000000
	mov ebx, edx
	add ecx, edx
	imul ecx, 100000000
	sub edi, ecx
	mov eax, 68DB9h
	mul esi
	mov ecx, [esp+1*4+3*4]
	mov esi, 100
	jnc JoNext1
	cmp edx, 9
	jna Jo0
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx], edx
Jo1:
	mul esi
Jo1a:
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx+2], edx
Jo2:
	mul esi
Jo2a:
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx+4], edx
Jo3:
	mov eax, 68DB9h
	mul ebx
Jo3a:
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx+6], edx
Jo4:
	mul esi
Jo4a:
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx+8], edx
Jo5:
	mul esi
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx+10], edx
	mov eax, 28F5C29h
	mul edi
	mov eax, 68DB9h
	mov ebx, edx
	mul edx
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx+12], edx
	mul esi
	mov edx, dword ptr chartab[edx+edx]
	mov [ecx+14], edx
	mul esi
	mov ebp, [esp+2*4]
	mov edx, dword ptr chartab[edx+edx]
	imul ebx, esi
	mov [ecx+16], edx
	mov esi, [esp+1*4]
	sub edi, ebx
	mov ebx, [esp]
	add esp, 3*4
	movzx edx, word ptr chartab[edi+edi]
	lea eax, [ecx+20]
	mov edi, [esp+2*4]
	mov [ecx+18], edx
	ret 2*4
align 16
Jo0:
	add edx, 30h
	mov [ecx], edx
	add ecx, -1
	jne Jo1
align 16
JoNext1:
	mul esi
	jnc JoNext2
	cmp edx, 9
	lea ecx, [ecx-2]
	ja Jo1a

	add edx, 30h
	mov [ecx+2], edx
	add ecx, -1
	jne Jo2
align 16
JoNext2:
	mul esi
	jnc JoNext3
	cmp edx, 9
	lea ecx, [ecx-4]
	ja Jo2a

	add edx, 30h
	mov [ecx+4], edx
	add ecx, -1
	jne Jo3
align 16
JoNext3:
	mov eax, 68DB9h
	mul ebx
	jnc JoNext4
	cmp edx, 9
	lea ecx, [ecx-6]
	ja Jo3a

	add edx, 30h
	mov [ecx+6], edx
	add ecx, -1
	jne Jo4
align 16
JoNext4:
	mul esi
	lea ecx, [ecx-10]
	jnc Jo5
	cmp edx, 9
	lea ecx, [ecx+2]
	ja Jo4a
	add edx, 30h
	mov [ecx+8], edx
	add ecx, -1
	jne Jo5
b2a3264 endp
b2a3264_END:

ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:
OPT_Tmp2Asm	1
OPT_Wait	0
